;**********************************************************************
;
;              PROGRAMME DE MIXAGE DE 8 VOIES (16 BITS)
;              (C)1996 Alain Bonnet
;                 Assemble avec DEVPAC-DSP
;
;**********************************************************************
;
;         LE SON DMA
;         
;  Vous etes peut etre quelques uns  avoir lu que le Falcon etait 
; muni d'un DMA 8 pistes et vous avez peut etre ,comme moi, essay
; sans succes de le faire marcher en 8 pistes. Vous en etes peut etre 
; arriv  la conclusion que ce n'etait pas tout  fait vrai. Vous 
; avez tort et cet article va vous expliquer comment utiliser le DMA 
; en mode 4 voies stro.
; 
;  Le DMA est un circuit qui permet de lire des donnes en RAM et de
; les envoyer soit au DAC soit vers la matrice DSP. Dans le premier
; cas (DMA->DAC) vous avez remarquer que seul les deux premieres pistes 
; sur les huit etaient rellement entendues. Pour pouvoir entendre les
; huit voies il faut imperativement passer par le DSP.
; 
; 1):Voici le programme DSP grant huit voies:


;**********************************************************************


; Initialisation du DSP
;
:

adc        EQU     $ffef           ; ADC address   
dac        EQU     $ffef           ; DAC address
M_CRA      EQU     $FFEC           ; SSI Control Register A
M_CRB      EQU     $FFED           ; SSI Control Register B
M_SR       EQU     $FFEE           ; SSI Status Register
M_PCC      EQU     $FFE1           ; Port C Control Register
BCR        equ   $fffe
IPR        equ   $ffff
PBC        equ   $ffe0
HCR        equ   $ffe8    ;Host Control Register
HSR        equ   $ffe9    ;Host Status Register
HRX        equ   $ffeb    ;Host Receive Register
HTX        equ   $ffeb    ;Host Transmit Register


               org y:0
buf_vol         dsm     16
             
buf_vol_eff     dsm 12

out_buf          dsm  8        ; buffer d'entree
in_buf           dsm  8        ; buffer de sortie
                               
                org     y:$1000

buf_delay       dsm     $1000

              org x:$1000

calc_buf    dsm  $1000         

                  org p:$0
    jmp        start                  ; on saute au debut du programme


; ici on met la routine de reception
; il s'agit d'une interruption courte.

          org p:$c
  move    x:adc,y:(r6)+

; Idem, pour la routine d'mission.

           org   p:$10
  movep       y:(r7)+,x:dac

          org     p:$20
  movep   x:HRX,y:(r5)+

          org     p:$22
  movep   y:(r0)+,x:HRX

; Programme principal

           org  p:$40
start      movep    #$01F8,X:M_PCC           ; Mode SSI.
 movep    #$4700,X:M_CRA                ; 16 bits, Stro.*4
 movep    #$F800,X:M_CRB   ; Interruptions RX/TX OK, activer RX/TX, NetWork
 movep    #0,x:BCR         ; Control du BUS: TOUJOURS ZERO
 movep    #1,x:PBC         ; Port B = HOST
 bset    #0,x:HCR
 bset    #1,x:HCR
 movep   #$3800,x:IPR      ; IPL 2 pour SSI  IPL 1 pour HOST

 move    #in_buf,r6; REcept ADC
 move    #8-1,m6

 move    #out_buf,r7;Envoi DAC
 move    #8-1,m7

 move    #buf_vol,r5;recept host
 move    #28-1,m5

 move    #in_buf,r0; envoi host
 move    #8-1,m0

 move    #buf_vol,r4
 move    #16-1,m4

 move    #buf_delay,r1
 move    #$1000-1,m1
 move    #$500,n1

 andi    #$fc,mr; Interruptions actives

;
; Routine principale
; 1) Attendre que des donnes arrivent.
; 1.1) Ces donnes on t lu par la routine d'interruption
; 2) Lire ces donnes
; 3) calculer le resultat(mixage)
; 4) Ecrire ces donnes en mmoire
;   4.1) C'est la routine d'interruption qui crira les donnes
;       sur le port SSI
; 5) Reboucler en (1)
;


main; Etape (1)
; ---------

ba1    jclr  #3,x:M_SR,ba1
ba2    jset  #3,x:M_SR,ba2


; Etape (2) 
; ---------

 move    y:in_buf,x1        ;           lit trak1
 move    y:buf_vol_eff,y1   ;        lit send eff1
 mpy     x1,y1,b          y:(r4)+,y1     ; dans b =send_delay

     ;  lit left vol track1
 mpy     x1,y1,a       y:in_buf+1,x0   ;dans a=left_out    lit trak2
 move    y:buf_vol_eff+1,y0
 mac     x0,y0,b         y:(r4)+,y0
 mac     x0,y0,a        y:in_buf+2,x1
 move    y:buf_vol_eff+2,y1
 mac     x1,y1,b         y:(r4)+,y1
 mac     x1,y1,a        y:in_buf+3,x0
 move    y:buf_vol_eff+3,y0
 mac     x0,y0,b         y:(r4)+,y0
 mac     x0,y0,a        y:in_buf+4,x1
 move    y:buf_vol_eff+4,y1
 mac     x1,y1,b         y:(r4)+,y1
 mac     x1,y1,a        y:in_buf+5,x0
 move    y:buf_vol_eff+5,y0
 mac     x0,y0,b         y:(r4)+,y0
 mac     x0,y0,a        y:in_buf+6,x1
 move    y:buf_vol_eff+6,y1
 mac     x1,y1,b         y:(r4)+,y1
 mac     x1,y1,a        y:in_buf+7,x0
 move    y:buf_vol_eff+7,y0
 mac     x0,y0,b         y:(r4)+,y0
 mac     x0,y0,a         y:(r1),x0;x0 sortie delay

 move    b1,y:(r1)+      ;delay send
 clr    b
 move    y:(r1+n1),b0

 asl b

 add  x0,b
 move b,x0

 move    y:buf_vol_eff+8,y0    ;lit vol left effet
 mac     x0,y0,a


 move    y:buf_vol_eff+9,y0    ;lit vol left effet
 mpy     x0,y0,b        y:in_buf,x1
 move    y:(r4)+,y1
 mac     x1,y1,b        y:in_buf+1,x0
 move    y:(r4)+,y0
 mac     x0,y0,b        y:in_buf+2,x1
 move    y:(r4)+,y1
 mac     x1,y1,b        y:in_buf+3,x0
 move    y:(r4)+,y0
 mac     x0,y0,b        y:in_buf+4,x1
 move    y:(r4)+,y1
 mac     x1,y1,b        y:in_buf+5,x0
 move    y:(r4)+,y0
 mac     x0,y0,b        y:in_buf+6,x1
 move    y:(r4)+,y1
 mac     x1,y1,b        y:in_buf+7,x0
 move    y:(r4)+,y0
 mac     x0,y0,b       
 
 move    a,x1     y:buf_vol_eff+10,y1
 mpy     x1,y1,a         
 move    b,x1     y:buf_vol_eff+11,y1
 mpy     x1,y1,b
       

; Etape (4)
; ---------

 move   a1,y:out_buf
 move   b1,y:out_buf+1



; Etape (5)
; ---------

 jmp main


  end


;       fin du programme

;*********************************************************************
;
;
;  Quelques commentaires importants:
;           
;       1):  L'initialisation du SSI Control Register A: 
;    Il faut l'initialiser en mode NETWORK 8 voies . ($4700 dans M_CRA)
;       2):  Autoriser les interuptions SSI en emission et rcption
;       et autoriser les interuptions HOST en reception.
;       3):  Regler les niveaux de priorit pour les interuptions (IPL)
;        
;   La suite se passe de commentaires sauf l'tape (4):
;       En sortie :l'interuption DAC ,si elle envoie 8 donnes ,seule les
;      deux premieres seront sorties sur le DAC en voies gauche et 
;      droite.
;      
;    Voil pour ce qui est de programation du DSP. Ce programme peut 
;    surement etre optimis et il est possible d'y ajouter une section 
;    effet. A vous de voir.
;    
;   Cot 68030:
;   
;   La programation cot 68030 demande quelques rgles:
;     
;     1): Faire les diffrentes connexions dans la matrice
;          DMA->DSP     DSP->DAC    devconnect   (xbios $8B)
;     2): Ne pas oublier de connecter le DSP  la matrice
;         dsptristate       (xbios $89)
;     3): Fixer  4 le nombre de pistes stro en lecture
;         settracks         (xbios $85)
;     
;     4) le reste se rgle suivant vos besoins personnel
;         setmode,setbuffer,soundcmd...
;
;
; ***************** COMMENTAIRES  *****************************
;
; Ce petit programme sert de base si vous souhaitez faire
; de la lecture DMA en 8 pistes.
;
;  Attention les donnees doivent etre envoyees par paquet dans 
;  le port host. 8 words pour le volume des 8 pistes, 8 words
;  pour l'envoi dans l'effet, 2 words pour le volume (L/R) du
;  retour d'effet et 2 words pour le volume de sortie du DSP.
;   Le volume de sortie doit etre gere par le DSP car sinon
;  on ne peut pas couper completement le son.
;    Vous pouvez vous servir de ce programme en connectant
;  la sortie DMAsound a l'entree du DSP ,la sortie du DSP
;  aux convertisseurs DAC . Le DMA doit etre configure en
;  mode 4 pistes (stereo) pour la lecture (fonctions XBIOS).
;
;************************************************************



