
;-------------  Constant declarations  --------------------
adc			equ	$ffef		; ADC address
dac			equ	$ffef		; DAC address
M_CRA		EQU $FFEC   ; SSI Control Register A
M_CRB		EQU $FFED   ; SSI Control Register B
M_SR		EQU $FFEE   ; SSI Status Register
M_PCC		EQU $FFE1   ; Port C Control Register
BCR			equ	$fffe
IPR			equ	$ffff
PBC			equ	$ffe0
HCR			equ	$ffe8		;Host Control Register
HSR			equ	$ffe9		;Host Status Register
HRX			equ	$ffeb		;Host Receive Register
HTX			equ	$ffeb		;Host Transmit Register


doff_i 			equ      -$1000
ddeltaf 		equ      0.0026607539
dspeed_i 		equ      14600
dregen 			equ      0.5888888889

delay				equ			$1000
dmax				equ			4096		;125 ms



		org y:$0
out_buf				dsm	2		; buffer out
in_buf				dsm	2		; buffer in



		org x:$0
vol_input 		dc  $600000		;0->$7fffff
vol_output		dc  $700000		; "    "
regen     		dc  dregen  	;feedback "    " 

doff					dc	doff_i    	; delay time  -$1000->0
ddelta				dc	0.000925			; rate

dspeed				dc	dspeed_i    ;speed


dtoggle		dc	0		
delayout 	dc	0


;----------------------------------------------------------

					org	p:$0
			jmp	start			; on saute au debut du programme

					org	p:$c
			movep	x:adc,y:(r6)+

					org	p:$10
			movep	y:(r7)+,x:dac
			
          org     p:$40		; program start address
start
	movep	#$01F8,X:M_PCC		; diverses initialisations
	movep	#$4100,X:M_CRA		; pour le port SSI et le port
	movep	#$F800,X:M_CRB		; HOST
	movep	#0,x:BCR
  move    #16,x:HCR
  movep   #$3000,x:IPR      ; IPL 2 pour SSI  
	movep	#$1,x:PBC
	
	move	#in_buf,r6
	move	#2-1,m6	
	move	#out_buf,r7
	move	#2-1,m7
		
	move	#delay,r1			;delay line input
 	movec	#dmax-1,m1			;
	move	#doff_i,n1			;distance to output
	 
	andi	#$fc,mr		;Interruptions activees
	jmp main
	
GetCoefs
    move  #vol_input,r5	
		movep	x:HRX,n5
    
lp3		jclr	#0,x:HSR,lp3
		movep	x:HRX,x:(r5+n5)
ReadHost	rts
		
main
      	jsset	#0,x:HSR,GetCoefs
ba1    jclr  #3,x:M_SR,ba1
ba2    jset  #3,x:M_SR,ba2

	clr	a	   x:vol_input,x1		;clr a, get input scale
	clr	b	   x:vol_output,y1			;clr b, get output scaler

	move		x:<delayout,y0		;get delay out

	move		x:regen,x0			;do regen term
	mac 	x0,y0,a						; delay * feed
	mac  	x0,y0,b

	move		y1,x0   ;vol_out

	mac 	y0,x0,b	  y:<in_buf,x0		;b = vol_out * delay, x0=in_l
	
	mac 	x0,y1,b		b,y0       	    ;b += .5 * in_l, y0=b
	
	macr	x0,x1,a   b,y:<out_buf		;a += x1 * in_l, L = b
;	move	y0,b		                  ;b = -y0
	neg	  b	        y:<in_buf+1,x0	;x0 = in_r
	macr	x0,y1,b				            ;b += .5 * in_r
	macr	x0,x1,a	  b,y:<out_buf+1	;R = b, a += x1 * in_r
		   
	move		a,x:(r1)+	  ;dans delay line
	
	move		x:doff,a		;a = current offset (-33)
	move		x:ddelta,x1		;x = current delta(0)
	add	x,a
	move		a,x:doff		;new offset = a + x
	move		a1,n1
	move		x1,b			;save delta for later use			
	move		x:doff,a	;compute |frac(doff)|
	lsr	a				#$800000,x0
	or	x0,a	  #.5,x1
	move	a1,x0
	mpy	-x0,x1,a
	tst	b		a,y0		;y0 = 0.5 * |frac(doff)|
	jpl	shorter				;on positive delta, the delay is shortening
	move		(r1)-			;get previous sample
	move		x:(r1+n1),x0
	mpy	y0,x0,a			#.5,b			;scale
	sub	y0,b				(r1)+			;compute scale for cur sample
	move			b,y0
	move		x:(r1+n1),x0		;get cur sample
	mac	x0,y0,a				;scale and sum
	jmp	endpan

shorter
	move		x:(r1+n1),x0		;get cur sample
	mpy	y0,x0,a			#.5,b			;scale
	sub	y0,b			(r1)+			;compute scale for next sample
	move			b,y0
	move		x:(r1+n1),x0		;get next sample
	mac	x0,y0,a	(r1)-			;scale and sum
endpan
	move		a,x:<delayout		;store resulting output

; update the triangle wave modulation

	move		x:<dtoggle,a		;decrement toggle count
	move		x:dspeed,x0
	sub	x0,a
	move		a,x:<dtoggle
	jgt	notogg				;time to toggle?
	move		x:<dspeed,x0		;yes, negate delta and reset
	move		x:<ddelta,a
	neg			a			x0,x:<dtoggle
	move		a,x:<ddelta
notogg
    jmp main                

  end