
; FIR algoritme   programmed by Bonnet Alain @1997


;-------------  Constant declarations  --------------------
adc			equ	$ffef		; ADC address
dac			equ	$ffef		; DAC address
M_CRA		EQU $FFEC   ; SSI Control Register A
M_CRB		EQU $FFED   ; SSI Control Register B
M_SR		EQU $FFEE   ; SSI Status Register
M_PCC		EQU $FFE1   ; Port C Control Register
BCR			equ	$fffe
IPR			equ	$ffff
PBC			equ	$ffe0
HCR			equ	$ffe8		;Host Control Register
HSR			equ	$ffe9		;Host Status Register
HRX			equ	$ffeb		;Host Receive Register
HTX			equ	$ffeb		;Host Transmit Register

ntap	equ	63		; number of taps FIR
tapmod	equ	ntap-1		; number of taps minus 1	 


		org x:$1000
dlyline				dsm ntap*2		; allocates mod memory for the FIR delay line

		org y:$0
out_buf				dsm	2		; buffer out
in_buf				dsm	2		; buffer in

tap_fir 			dsm ntap   ;Fir coef

;----------------------------------------------------------

					org	p:$0
			jmp	start			; on saute au debut du programme

					org	p:$c
			movep	x:adc,y:(r6)+

					org	p:$10
			movep	y:(r7)+,x:dac


          org     p:$40		; program start address
start
	movep	#$01F8,X:M_PCC		; diverses initialisations
	movep	#$4100,X:M_CRA		; pour le port SSI et le port
	movep	#$F800,X:M_CRB		; HOST
	movep	#0,x:BCR
 	movep	#16,x:HCR			; Initialisation du port HOST
	movep	#$3000,x:IPR
	movep	#$1,x:PBC
	
	move  #ntap-1,m0	; tap line modulus
	move  #dlyline,r0 	; start of delay line	
	move  #ntap-1,m4
	move  #tap_fir,r4
	move	#tap_fir,r5
	move	#ntap-1,m5
	move	#in_buf,r6
	move	#2-1,m6	
	move	#out_buf,r7
	move	#2-1,m7
	 
	andi	#$fc,mr		;Interruptions activees
	
	jmp   main

GetCoefs	
			movep	x:HRX,y:(r5)+
			do		#ntap-1,ReadHost
lp3
				jclr	#0,x:HSR,lp3
				movep	x:HRX,y:(r5)+
ReadHost	rts


main
		jsset	#0,x:HSR,GetCoefs
main2
		jclr	#3,x:M_SR,main2

			clr		a
			clr		b			x:(r0)+,x0	y:(r4)+,y1
		do		#ntap-1,loopfir
			mac		x0,y1,a		x:(r0)+,x0
			mac		x0,y1,b		x:(r0)+,x0	y:(r4)+,y1
loopfir		macr	x0,y1,a		x:(r0)+,x0
			macr	x0,y1,b

		move  y:in_buf,x0
		move  x0,x:(r0)+
			move	a,y:out_buf
		
    move 	y:in_buf+1,x0
    move  x0,x:(r0)+
			move	b,y:out_buf+1

    jmp main                

  end