/*					Calculate FIR-filter coefficients					*/
/*	main routines from 'firdemo' by Frank Kiesow and	*/
/*	shell written by Roel van de Kraats								*/
/*  Extended by Bonnet Alain                  */
/*   for eXtendSozobon Compilator             */
 
/* tabsize=2	*/

#include <xdlibs\stdio.h>
#include <xdlibs\stdlib.h> 
#include <xdlibs\osbind.h>
#include <xdlibs\math.h>
#include <aes.h>
#include <xdlibs\string.h>
#include "tst_fir2.h"

#define FALSE 				0
#define TRUE  				1
#define	MAX_COEFF 		1000
#define STFILELEN     13    /* Maximale Lnge eines Filenamens     */
#define STPATHLEN     64    /* Maximale Lnge eines Pfades         */
#define EOS           '\0'  /* Ende eines Strings                  */
#define BACKSLASH     '\\'

typedef char DSP_WORD[3];
void cale_rsc (arbre);
void show_dialog (arbre);
int create_rsc_wind(arbre);
int charge_lod(file);
void do_dsp_bloc(int ncoef);

long		get_value(OBJECT *tree,int obj);
void		put_value(OBJECT *tree,int obj,long value);
int 		new_filter(void);
int 		fpfix(float src,DSP_WORD dest);
void 		fir_tp(int n,double ta,double wg);
void   	fir_hp(int n,double ta,double wg);
int   	fir_bp(int n,double ta,double low_wg,double up_wg);
int   	fir_bs(int n,double ta,double low_wg,double up_wg);
void 		fir_hamming_win(int ordnung);
void 		fir_hanning_win(int ordnung);
void 		fir_blackman_win(int ordnung);
void 		fir_bartlett_win(int ordnung,double smpl_freq);
void 		fir_lanczos_win(int ordnung);
void 		fir_fejer_win(int ordnung);
void		mouse_on( void );
void		mouse_off( void );
void		event_loop( void );


DSP_WORD	coeff[MAX_COEFF]; 	/* Maximal xx Koeffizienten a' 3 Bytes		  	*/
double		a_k[MAX_COEFF];		/* Maximal 100 Filterkoeffizienten						*/
OBJECT		*maintree;
s[50];

long DspParBlk[MAX_COEFF];
int FIRability;
char *FIRname = "FIR.LOD";

int  wind_handle,
     pxyarray[4],
     x,y,w,h;
int  wx[2] = {20, 50},      /* Dimensions extrieures des fentres */
     wy[2] = {20, 50},      /* avec valeurs initiales */
     ww[2] = {400, 300},
     wh[2] = {320, 320};
     
int  xdesk, ydesk, wdesk, hdesk;        /* Dimensions du Bureau */
int  i, window;

int  tampon[8],
     title,
     quit = 0;
     
unsigned int handle;

long size;
double 	smpl_freq,
				lower_freq,
				upper_freq;
int 		n_coeff;

int main(void)
{
	int x,y,w,h, obj;
	long test_val;
	int which, opened;
 int mouse_x, mouse_y, mb, ks, kr, br;

	if ( appl_init( ) >=0 )
	{
		graf_mouse(ARROW,0);
		if (rsrc_load("TST_FIR2.RSC")!=0 && charge_lod(FIRname)!=0)
		{
			rsrc_gaddr(0,TREE1,&maintree);
			
			if (create_rsc_wind(maintree) == -1)  /* La fonction retourne 1 en cas d'erreur */
    {
    form_alert (1, "[3][Dsol!|Plus de handle fentre disponible!][OK]");
    }
   else
   {
			show_dialog (maintree);
			do
			{
					which = evnt_multi( 32+16+3, 	258, 3, 0,	0, 0, 0, 0, 0,	0, 0, 0, 0, 0,
						 tampon,	0, 0,
							&mouse_x, &mouse_y, &mb,	&ks, &kr,	&br );
       if (which & MU_BUTTON)
			       {				
            if (wind_find(mouse_x,mouse_y) == wind_handle)
               {
                obj = objc_find(maintree, 0, 10, mouse_x, mouse_y);
                if (obj)
                   { switch (obj)
				{
					case	LOWP  	:	maintree[LOWFQ].ob_state |= DISABLED;
														maintree[UPFQ].ob_state &= ~DISABLED;
														maintree[LOWFQ].ob_flags &= ~EDITABLE;
														maintree[UPFQ].ob_flags |= EDITABLE;
														maintree[LOWP].ob_state |= SELECTED;
														maintree[HIGHP].ob_state &= ~SELECTED;
														maintree[BANDP].ob_state &= ~SELECTED;
														maintree[BANDS].ob_state &= ~SELECTED;
														objc_draw(maintree,LOWFQ,MAX_DEPTH,x,y,w,h);
														objc_draw(maintree,UPFQ,MAX_DEPTH,x,y,w,h);
														objc_draw(maintree,CADREFLT,MAX_DEPTH,x,y,w,h);
														break;
					case	HIGHP 	:	maintree[LOWFQ].ob_state &= ~DISABLED;
														maintree[UPFQ].ob_state |= DISABLED;
														maintree[LOWFQ].ob_flags |= EDITABLE;
														maintree[UPFQ].ob_flags &= ~EDITABLE;
														maintree[LOWP].ob_state &= ~SELECTED;
														maintree[HIGHP].ob_state |= SELECTED;
														maintree[BANDP].ob_state &= ~SELECTED;
														maintree[BANDS].ob_state &= ~SELECTED;
														objc_draw(maintree,LOWFQ,MAX_DEPTH,x,y,w,h);
														objc_draw(maintree,UPFQ,MAX_DEPTH,x,y,w,h);
														objc_draw(maintree,CADREFLT,MAX_DEPTH,x,y,w,h);
														break;
					case	BANDP 	: 	maintree[LOWFQ].ob_state &= ~DISABLED;
														maintree[UPFQ].ob_state &= ~DISABLED;
														maintree[LOWFQ].ob_flags |= EDITABLE;
														maintree[UPFQ].ob_flags |= EDITABLE;
														maintree[LOWP].ob_state &= ~SELECTED;
														maintree[HIGHP].ob_state &= ~SELECTED;
														maintree[BANDP].ob_state |= SELECTED;
														maintree[BANDS].ob_state &= ~SELECTED;
														objc_draw(maintree,LOWFQ,MAX_DEPTH,x,y,w,h);
														objc_draw(maintree,UPFQ,MAX_DEPTH,x,y,w,h);
													 objc_draw(maintree,CADREFLT,MAX_DEPTH,x,y,w,h);
														break;
						
					case 	BANDS 	:	maintree[LOWFQ].ob_state &= ~DISABLED;
														maintree[UPFQ].ob_state &= ~DISABLED;
														maintree[LOWFQ].ob_flags |= EDITABLE;
														maintree[UPFQ].ob_flags |= EDITABLE;
														maintree[LOWP].ob_state &= ~SELECTED;
														maintree[HIGHP].ob_state &= ~SELECTED;
														maintree[BANDP].ob_state &= ~SELECTED;
														maintree[BANDS].ob_state |= SELECTED;
														objc_draw(maintree,LOWFQ,MAX_DEPTH,x,y,w,h);
														objc_draw(maintree,UPFQ,MAX_DEPTH,x,y,w,h);
														objc_draw(maintree,CADREFLT,MAX_DEPTH,x,y,w,h);
														break;
					case FQMOINS :
					          if (get_value(maintree, SAMPFQ) != 32780L)
					            {
					           			sprintf(s,"32780");
					           			Devconnect(3,2,0,2,1);
 		                strcpy(maintree[SAMPFQ].ob_spec.tedinfo->te_ptext,s); 					          
					              objc_draw(maintree,SAMPFQ,MAX_DEPTH,x,y,w,h);
					            }
					          break;
					case FQPLUS :
					          if (get_value(maintree, SAMPFQ) != 49170L)
					            {
					           			sprintf(s,"49170");
					           			Devconnect(3,2,0,1,1);
 		                strcpy(maintree[SAMPFQ].ob_spec.tedinfo->te_ptext,s); 					          
					              objc_draw(maintree,SAMPFQ,MAX_DEPTH,x,y,w,h);
					            }
				          break;
					case LOWFQP :
					          if (get_value(maintree, LOWFQ) < 16380L)
					            {
					              test_val = get_value(maintree, LOWFQ);
					              test_val=test_val+10;					              
					           			sprintf(s,"%d",(int)test_val);
 		                strcpy(maintree[LOWFQ].ob_spec.tedinfo->te_ptext,s); 					          
					              objc_draw(maintree,LOWFQ,MAX_DEPTH,x,y,w,h);  
					            }
				          break;
					case LOWFQM :
					          if (get_value(maintree, LOWFQ) > 10L)
					            {
					              test_val = get_value(maintree, LOWFQ);
					              test_val=test_val-10;					              
					           			sprintf(s,"%d",(int)test_val);
 		                strcpy(maintree[LOWFQ].ob_spec.tedinfo->te_ptext,s); 					          
					              objc_draw(maintree,LOWFQ,MAX_DEPTH,x,y,w,h);  
					            }
				          break;
					case HIGHFQP :
					          if (get_value(maintree, UPFQ) < 16380L)
					            {
					              test_val = get_value(maintree, UPFQ);
					              test_val=test_val+10;					              
					           			sprintf(s,"%d",(int)test_val);
 		                strcpy(maintree[UPFQ].ob_spec.tedinfo->te_ptext,s); 					          
					              objc_draw(maintree,UPFQ,MAX_DEPTH,x,y,w,h);  
					            }
				          break;
					case HIGHFQM :
					          if (get_value(maintree, UPFQ) > 10L)
					            {
					              test_val = get_value(maintree, UPFQ);
					              test_val=test_val-10;					              
					           			sprintf(s,"%d",(int)test_val);
 		                strcpy(maintree[UPFQ].ob_spec.tedinfo->te_ptext,s); 					          
					              objc_draw(maintree,UPFQ,MAX_DEPTH,x,y,w,h);  
					            }
				          break;
     case BART :  maintree[BART].ob_state |= SELECTED;
                maintree[BLAC].ob_state &= ~SELECTED;
                maintree[FEJE].ob_state &= ~SELECTED;
                maintree[HANN].ob_state &= ~SELECTED;
                maintree[HAMM].ob_state &= ~SELECTED;
                maintree[LANC].ob_state &= ~SELECTED;
                maintree[RECT].ob_state &= ~SELECTED;
                objc_draw(maintree,CADREWIN,MAX_DEPTH,x,y,w,h);
                break;
     case BLAC :  maintree[BART].ob_state &= ~SELECTED;
                maintree[BLAC].ob_state |= SELECTED;
                maintree[FEJE].ob_state &= ~SELECTED;
                maintree[HANN].ob_state &= ~SELECTED;
                maintree[HAMM].ob_state &= ~SELECTED;
                maintree[LANC].ob_state &= ~SELECTED;
                maintree[RECT].ob_state &= ~SELECTED;
                objc_draw(maintree,CADREWIN,MAX_DEPTH,x,y,w,h);
                break;
     case FEJE :  maintree[BART].ob_state &= ~SELECTED;
                maintree[BLAC].ob_state &= ~SELECTED;
                maintree[FEJE].ob_state |= SELECTED;
                maintree[HANN].ob_state &= ~SELECTED;
                maintree[HAMM].ob_state &= ~SELECTED;
                maintree[LANC].ob_state &= ~SELECTED;
                maintree[RECT].ob_state &= ~SELECTED;
                objc_draw(maintree,CADREWIN,MAX_DEPTH,x,y,w,h);
                break;                
     case HANN :  maintree[BART].ob_state &= ~SELECTED;
                maintree[BLAC].ob_state &= ~SELECTED;
                maintree[FEJE].ob_state &= ~SELECTED;
                maintree[HANN].ob_state |= SELECTED;
                maintree[HAMM].ob_state &= ~SELECTED;
                maintree[LANC].ob_state &= ~SELECTED;
                maintree[RECT].ob_state &= ~SELECTED;
                objc_draw(maintree,CADREWIN,MAX_DEPTH,x,y,w,h);
                break;
     case HAMM :  maintree[BART].ob_state &= ~SELECTED;
                maintree[BLAC].ob_state &= ~SELECTED;
                maintree[FEJE].ob_state &= ~SELECTED;
                maintree[HANN].ob_state &= ~SELECTED;
                maintree[HAMM].ob_state |= SELECTED;
                maintree[LANC].ob_state &= ~SELECTED;
                maintree[RECT].ob_state &= ~SELECTED;
                objc_draw(maintree,CADREWIN,MAX_DEPTH,x,y,w,h);
                break;
     case LANC :  maintree[BART].ob_state &= ~SELECTED;
                maintree[BLAC].ob_state &= ~SELECTED;
                maintree[FEJE].ob_state &= ~SELECTED;
                maintree[HANN].ob_state &= ~SELECTED;
                maintree[HAMM].ob_state &= ~SELECTED;
                maintree[LANC].ob_state |= SELECTED;
                maintree[RECT].ob_state &= ~SELECTED;
                objc_draw(maintree,CADREWIN,MAX_DEPTH,x,y,w,h);
                break;
     case RECT :  maintree[BART].ob_state &= ~SELECTED;
                maintree[BLAC].ob_state &= ~SELECTED;
                maintree[FEJE].ob_state &= ~SELECTED;
                maintree[HANN].ob_state &= ~SELECTED;
                maintree[HAMM].ob_state &= ~SELECTED;
                maintree[LANC].ob_state &= ~SELECTED;
                maintree[RECT].ob_state |= SELECTED;
                objc_draw(maintree,CADREWIN,MAX_DEPTH,x,y,w,h);
                break;
     case NOCALC :
                wind_close (wind_handle);
                wind_delete (wind_handle);
                opened = 0;   /* dsigner comme ferm */
                break;
                
					case GOCALC :
					          new_filter();
					          				/*			save_filter();  */
					         	maintree[GOCALC].ob_state &= ~SELECTED;
					     			  objc_draw(maintree,ROOT,MAX_DEPTH,x,y,w,h);
					          break;
				}
				
				}
				}
				}
				      if(tampon[3] == wind_handle )
      {
        switch (tampon[0])
        {
          case 20:               /* Redraw */
           /* redraw ();  */
               show_dialog (maintree);
               tampon[3] = 0;
            break;         
          case 21:               /* Topped */
            wind_set(wind_handle, 10, 0, 0, 0, 0);  /* 10 -> Top */
            break;              

          case 28:               /* Barre de dplacement */
            wx[0] = tampon[4];
            wy[0] = tampon[5];
            wind_set (wind_handle, 5, wx[0], wy[0], ww[0], wh[0]); /* Nouvelles dimensions */
            tampon[3] = 0;
            cale_rsc(maintree);
            break;
              
          case 22:               /* Close Box (bote fermeture) */
            wind_close (wind_handle);
            wind_delete (wind_handle);
            opened = 0;   /* dsigner comme ferm (l bug dur)*/
            break;
        }
      }											
			}
			while ((obj != NOCALC) || (opened != 0));
		}	
   Dsp_Reserve(0,0);
		 Dsp_Unlock();  
			rsrc_free( );
		}
		else
			form_alert(1,"[3][RSC-File not found][Exit]");
		appl_exit( );
	}
	return(0);
}
int create_rsc_wind(OBJECT *tree)
{
  int  x, y, w, h;   
  form_center (tree, &x, &y, &w, &h);
  wind_handle = wind_create (11, x, y, w, h+22);
  wind_set (wind_handle, 2, " * *  F.I.R.  * * ", 0, 0);         
  wind_open (wind_handle, x, y, w, h+22);
  wx[0] = x;
  wy[0] = y;
  ww[0] = w;
  wh[0] = h+22;
  return (wind_handle);     
}

void cale_rsc (OBJECT *tree)
{
 int x, y, w, h; 
 wind_get (wind_handle, 4,&x, &y, &w, &h); 
 tree[0].ob_x = x;
 tree[0].ob_y = y;
}
void show_dialog (OBJECT *tree)  /* Affichage d'une bote de dialogue */

{
  int  x, y, w, h;
    cale_rsc(tree);
    wind_get (wind_handle, 4,&x, &y, &w, &h);    
    objc_draw (tree, 0, 12, x, y, w, h); 
}

int charge_lod(file)
char file[13];
{       
	    unsigned int ability;
	    char *adr;
        int status;
        adr = malloc(4096L);  
        if (adr)
            {		
             ability=Dsp_RequestUniqueAbility();
		           status = Dsp_LoadProg(file,ability,adr);
		           
		           Dsptristate(1,1);
					        Devconnect(3,2,0,1,1);
		           Devconnect(1,8,0,1,1);
		           Soundcmd(4,2);
		           Soundcmd(5,0);
		           Setmode(1);
		           Settracks(0,0);
			           Mfree(adr);
             }  
            return (ability);
}

long get_value(OBJECT *tree,int obj)
{
	char s[10];
	int i;
	strcpy(s,tree[obj].ob_spec.tedinfo->te_ptext);
	for (i=0;i<9;i++)
	{
		if (s[i]=='_')
			s[i]=' ';
	}
	return atol(s);
}

int fpfix(float src,DSP_WORD dest)
{
	float x;
	unsigned long *y1;					/* Alias fr (float) x											*/
	unsigned long	y0;
	char *ptr;									/* Alias fr (unsigned long) y0							*/
	y1 = (unsigned long *)&x;
	ptr = (char *)&y0;
	if(fabs(src) >= 2.0e-7)
	{ 
		x = src;
		y0 = *y1<<8;							/* Mantisse (fast)ganz nach links schieben	*/
	
		*y1 >>= 23;								/* Exponent in LSB													*/
		*y1 &= 0xffL;							/* Vorzeichen rausschmeissen								*/
		*y1 = 0x7fL - *y1;				/* Anzahl der Rechtsshifts berechnen				*/
	
		y0 |= 0x80000000uL;				/* Fhrende '1' einfgen										*/
		y0 >>= *y1;					  		/* Denormalisieren...												*/
		if(src < 0.0)							/* (Float) x < 0.0 ?												*/
		  y0 = ~y0;								/* Dann 1'er Komplement bilden							*/
		y0 >>= 7;									/* ... 24 Bit Wert erzeugen									*/
		if(y0 & 0x01L)						/* Letzte rausgeschobene Stelle  = 1?				*/
			y0++;										/* ...dann aufrunden												*/	
		y0 >>= 1;	
	}	
	else
	  y0 = 0L;
	dest[0] = ptr[1];
	dest[1] = ptr[2];
	dest[2] = ptr[3];
	return 1; 
}

void do_dsp_bloc(int ncoef)
{
 	char s[256];
 int i;
 long ft;
 for (i = 0; i<=ncoef;)
 { 
 			sprintf(s,"0x%02x%02x%02x",(int)coeff[i][0] & 0xff,(int)coeff[i][1] & 0xff,(int)coeff[i][2] & 0xff);

     ft = (long) strtol(s, NULL, 16); 
	    DspParBlk[i] = ft * 2;    
     s = "";
/* printf("\t %d\t %d\n", ft, DspParBlk[i]);  */
 i++;
 }
 	Dsp_BlkUnpacked(DspParBlk,2,0L,0L);  
 	Dsp_BlkUnpacked(DspParBlk+2,ncoef-2,0L,0L);
}

void fir_tp(int n, double ta, double wg)  /* FIR Tiefpass berechnen       */
{
  int k;
  double omega;
  double si;
  double si_k;
  double *coeff_ptr = a_k;
  omega = 2.0 * (wg/ta);
  si = M_PI * omega;
  *coeff_ptr++ = omega;       /* omega * Si(0) = omega * 1.0      				*/
  for(k=1;k<n;k++)
  {
  	si_k = (double)k * si;
    *coeff_ptr++ = omega * sin(si_k)/(si_k);
  } 
}

void fir_hp(int n, double ta, double wg) /* FIR Hochpass berechnen        */
{
  int k;
  fir_tp(n,ta,wg);                       /* Zuerst den entsprechenden     */
  a_k[0] = 1.0 - a_k[0]; 								 /* Tiefpass berechnen ... dann   */
  for (k=1;k<n;k++)                      /*  von Allpass(= 1)subtrahieren */
    a_k[k] = -a_k[k];
}

int fir_bp(int n, double ta, double low_wg,double up_wg)
{                               /* FIR Bandpass berechnen                 */
  int k;                        /* Ergibt sich als Differenz zweier       */
  double *h_vec;                /* Tiefpasse                              */  
  h_vec = (double *)Malloc((n+1) * sizeof(double));/* Hilfsvector erzeugen*/
  if(h_vec == 0L)
  {
  	form_alert(1,"[3][Out of Memory][Exit]");
    return FALSE;
  }  
  fir_tp(n,ta,low_wg);          /* Zuerst untere Grenzfrequenz berechnen  */
  for (k=0;k<n;k++)
    h_vec[k] = a_k[k];					/* ... und sichern                        */
  fir_tp(n,ta,up_wg);           /* Obere Grenzfrequenz berechnen          */
  for (k=0;k<n;k++)
    a_k[k] -= h_vec[k];						/* Differenz bilden                     */
  Mfree(h_vec);
  return TRUE;
}

int fir_bs(int n, double ta, double low_wg,double up_wg)
{                               /* FIR Bandsperre berechnen               */
  int k;                        /* Ergibt sich aus der Differenz eines    */
  if(!fir_bp(n,ta,low_wg,up_wg))/* Allpass(=1) und eines Bandpass         */
    return FALSE;
  a_k[0] =  1.0 - a_k[0];
  for (k=1;k<n;k++)
    a_k[k] = -a_k[k];
  return TRUE;  
}

void fir_hamming_win(int ordnung)   /* Fensterfunktion                    */
{
  int n;
  for (n=0;n<ordnung;n++)
    a_k[n] *= (0.54+0.46*cos(M_PI*n/ordnung));
}


void fir_hanning_win(int ordnung)   /* Fensterfunktion                    */
{
  int n;
  for (n=0;n<ordnung;n++)
    a_k[n] *= (0.5+0.5*cos(M_PI*n/ordnung));
}


void fir_blackman_win(int ordnung)  /* Fensterfunktion                    */
{
  int n;
  for (n=0;n<ordnung;n++)
    a_k[n] *= (0.42+0.5*cos(M_PI*n/ordnung)+0.08*cos(2*M_PI*n/ordnung));
}

void fir_bartlett_win(int ordnung,double smpl_freq)
{                                   /* Fensterfunktion                    */
  int n;
  double nenner;
  nenner = ordnung * smpl_freq;
  for (n=0;n<ordnung;n++)
    a_k[n] *= (1-fabs(n*smpl_freq)/nenner);
}

void fir_lanczos_win(int ordnung)   /* Fensterfunktion                    */
{
  int n;
  for (n=1;n<ordnung;n++)
    a_k[n] *= (sin(M_PI*n/ordnung)/(M_PI*n/ordnung));
}

void fir_fejer_win(int ordnung)     /* Fensterfunktion                    */
{
  int n;
  for (n=0;n<ordnung;n++)
    a_k[n] *= (1-fabs(n/ordnung));
}

int new_filter(void)
{
	double sum_coeff; 
	int i;
	n_coeff = 63;
	lower_freq = get_value(maintree,LOWFQ);
	upper_freq = get_value(maintree,UPFQ);
	smpl_freq = get_value(maintree,SAMPFQ);
	sum_coeff = 0.0;
	if(maintree[LOWP].ob_state == SELECTED)
		fir_tp(n_coeff,smpl_freq,upper_freq);
	else	
		if(maintree[HIGHP].ob_state == SELECTED)
			fir_hp(n_coeff,smpl_freq,lower_freq);
		else
		  if(maintree[BANDP].ob_state == SELECTED)
		  {
				if(!fir_bp(n_coeff,smpl_freq,lower_freq,upper_freq))
					return FALSE;
			}	
			else
			  if(maintree[BANDS].ob_state == SELECTED)
					if(!fir_bs(n_coeff,smpl_freq,lower_freq,upper_freq))
					  return FALSE;
	
	if(maintree[BART].ob_state == SELECTED)
		fir_bartlett_win(n_coeff,smpl_freq);
	else	
		if(maintree[BLAC].ob_state == SELECTED)
			fir_blackman_win(n_coeff);	
		else	
			if(maintree[FEJE].ob_state == SELECTED)
				fir_fejer_win(n_coeff);	
			else	
				if(maintree[HAMM].ob_state == SELECTED)
					fir_hamming_win(n_coeff);
				else
					if(maintree[HANN].ob_state == SELECTED)
						fir_hanning_win(n_coeff);
					else
						if(maintree[LANC].ob_state == SELECTED)
							fir_lanczos_win(n_coeff);
						else	
							if(maintree[RECT].ob_state == SELECTED)		/* Default		*/
								;
	for(i=0;i<n_coeff;i++)				/* Betrag der Filterkoefizienten = 1			*/
	  sum_coeff += fabs(a_k[i]);
	sum_coeff = 1.0/sum_coeff;  
	for(i=0;i<n_coeff;i++)				/* Koeffizienten von Double- in						*/
	{															/* 24 Bit Festpunktformat wandeln					*/	
		a_k[i] *= sum_coeff;
		fpfix((float)a_k[i],coeff[i]);
	}
 do_dsp_bloc(n_coeff);
	return TRUE;
}			
